#!/usr/bin/webif-page
<? 
. /usr/lib/webif/webif.sh

header "Proxy" "Settings" "@TR<<Proxy Settings>>"

prepare_files()
{
        if [ -h /etc/packetprotector.conf ] ; then
                cp /etc/packetprotector.conf /etc/packetprotector.conf.ORIG
                rm /etc/packetprotector.conf
                cp /rom/etc/packetprotector.conf /etc/packetprotector.conf
        fi
}

proxy_stop()
{
	IPADDR=`uci get network.lan.ipaddr`
	iptables -t nat -D prerouting_rule -i br-lan -p tcp --dport 80 -j DNAT --to $IPADDR
	#Fixed 2/14/08.  Thanks cmh714!
	echo 'Redirection disabled.'
	echo '<br />'
	killall dansguardian 2> /dev/null
	killall tinyproxy 2> /dev/null 
	echo 'Waiting for DansGuardian processes to terminate...'
	echo '<br />'
	echo '<pre>'
	DG_RUNNING=1
	DG_PID=`cat /var/run/dansguardian.pid`
	while [ $DG_RUNNING = 1 ] ; do
		ps -w | grep -e "^ *$DG_PID" 
		if [ $? != 0 ] ; then
			DG_RUNNING=0
		fi
		sleep 2
	done	
	echo '</pre>'
	echo '<br />'
	echo 'Done.'
	echo '<br /><br />'
}

export LD_LIBRARY_PATH=/packetprotector/usr/lib
BASEDIR="/packetprotector"
PROXY_ENABLED=`egrep "^dansguardian=" /etc/packetprotector.conf | cut -d "=" -f 2`
CF_ENABLED=`egrep "^dansguardian_cf=" /etc/packetprotector.conf | cut -d "=" -f 2`

if [ "$FORM_enabled" ] ; then
        if [ "X$FORM_enabled" = "X1" ] ; then
                if [ "X$PROXY_ENABLED" = "X1" ] ; then
			prepare_files
                        touch /etc/packetprotector.conf
                else
			prepare_files
                        /bin/sed -i "s/^dansguardian=.*/dansguardian=1/" /etc/packetprotector.conf
			echo 'Starting Dansguardian... (this will take a few minutes)'
			echo '<pre>'
			$BASEDIR/etc/init.d/S98dansguardian > /dev/null
			echo '</pre>'
                fi
                echo '<br />Enabled.'
                echo '<br /><br />'
        elif [ "X$FORM_enabled" = "X0" ] ; then
                if [ "X$PROXY_ENABLED" = "X1" ] ; then
			prepare_files
			proxy_stop
                        /bin/sed -i "s/^dansguardian=.*/dansguardian=0/" /etc/packetprotector.conf
                fi
                echo 'Disabled.'
                echo '<br /><br />'
        else
                echo 'Invalid value for variable "enabled".'
        fi
fi

if [ "$FORM_cfenabled" ] ; then
        if [ "X$FORM_cfenabled" = "X1" ] ; then
                if [ "X$CF_ENABLED" = "X1" ] ; then
			prepare_files
                        touch /etc/packetprotector.conf
                else
			prepare_files
                        /bin/sed -i "s/^dansguardian_cf=.*/dansguardian_cf=1/" /etc/packetprotector.conf
			echo '<pre>'
			cp /$BASEDIR/etc/dansguardian/lists/weightedphraselist.FILTERED /$BASEDIR/etc/dansguardian/lists/weightedphraselist
			echo 'Restarting Dansguardian.  This will take a couple of minutes.'
			proxy_stop
			sleep 5
			echo 'Stopped.'
			echo 'Starting...'
			$BASEDIR/etc/init.d/S98dansguardian > /dev/null
			echo '</pre>'
                fi
                echo '<br />Content filter enabled.'
                echo '<br /><br />'
        elif [ "X$FORM_cfenabled" = "X0" ] ; then
                if [ "X$CF_ENABLED" = "X1" ] ; then
			prepare_files
			cp /$BASEDIR/etc/dansguardian/lists/weightedphraselist.OPEN /$BASEDIR/etc/dansguardian/lists/weightedphraselist
                        /bin/sed -i "s/^dansguardian_cf=.*/dansguardian_cf=0/" /etc/packetprotector.conf
			echo '<pre>'
			echo 'Restarting Dansguardian.  This will take a couple of minutes.'
			proxy_stop
			sleep 5
			echo 'Stopped.'
			echo 'Starting...'
			$BASEDIR/etc/init.d/S98dansguardian > /dev/null
			echo '</pre>'
                fi
                echo 'Content filter disabled.'
                echo '<br /><br />'
        else
                echo 'Invalid value for variable "cfenabled".'
        fi
fi

PROXY_ENABLED=`egrep "^dansguardian=" /etc/packetprotector.conf | cut -d "=" -f 2`
CF_ENABLED=`egrep "^dansguardian_cf=" /etc/packetprotector.conf | cut -d "=" -f 2`
echo '<form enctype="multipart/form-data" method="post">'
if [ "X$PROXY_ENABLED" = "X1" ] ; then
	echo '<input type="radio" name="enabled" value="1" checked> Enabled'
	echo '<input type="radio" name="enabled" value="0"> Disabled'
else
	echo '<input type="radio" name="enabled" value="1"> Enabled'
	echo '<input type="radio" name="enabled" value="0" checked> Disabled'
fi
echo '<input type="submit" name="submit_enabled" value="Submit">'
echo '</form>'

echo '<form enctype="multipart/form-data" method="post">'
if [ "X$PROXY_ENABLED" = "X1" ] ; then
	echo '<br />'
	echo '<form enctype="multipart/form-data" method="post">'
	CF_ENABLED=`egrep "^dansguardian_cf=" /etc/packetprotector.conf | cut -d "=" -f 2`
	echo 'Content filter (pornography, gambling, etc.)-<br />'
	if [ "X$CF_ENABLED" = "X1" ] ; then
		echo '<input type="radio" name="cfenabled" value="1" checked> Enabled'
		echo '<input type="radio" name="cfenabled" value="0"> Disabled'
	else
		echo '<input type="radio" name="cfenabled" value="1"> Enabled'
		echo '<input type="radio" name="cfenabled" value="0" checked> Disabled'
	fi
	echo '<input type="submit" name="submit_cf" value="Submit">'
	echo '</form>'
	
	echo '<br />'
fi

LAST_UPDATED=`cat /packetprotector/usr/share/clamav/last_updated`
echo 'Signatures last updated '$LAST_UPDATED'.'
echo '<br /><br />'

footer ?>
<!--
##WEBIF:name:Proxy:2:Settings
-->
